<!DOCTYPE html>
<html lang='en'>

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Users Lists</title>
    <link rel="stylesheet" href="../public/css/bootstrap.min.css">
</head>

<body>
    <div class="container">
        <h3>User Lists</h3>
        <button type="button" class="btn btn-success mb-2" data-toggle="modal" data-target="#addModal">Add New</button>
        <table class="table table-striped">
            <thead>
                <tr>
                    <th>Name</th>
                    <th>Email</th>
                    <th>Password</th>
                    <th>Contact</th>
                    <th>Address</th>
                </tr>
            </thead>
            <tbody>
                <?php foreach($users as $row):?>
                <tr>
                    <td>
                        <?= $row->user_name;?>
                    </td>
                    <td>
                        <?= $row->user_email;?>
                    </td>
                    <td>
                        <?= $row->user_password;?>
                    </td>
                    <td>
                        <?= $row->user_contact;?>
                    </td>
                    <td>
                        <?= $row->user_address;?>
                    </td>
                    <td>
                        <a href="#" class="btn btn-info btn-sm btn-edit" 
                        data-id="<?= $row->user_id;?>"
                        data-name="<?= $row->user_name;?>" 
                        data-email="<?= $row->user_email;?>"
                        data-password="<?= $row->user_password;?>" 
                        data-contact="<?= $row->user_contact;?>"
                        data-address="<?= $row->user_address;?>">Edit</a>

                        <a href="#" class="btn btn-danger btn-sm btn-delete" 
                        data-id="<?= $row->user_id;?>">Delete</a>
                    </td>
                </tr>
                <?php endforeach;?>
            </tbody>
        </table>
    </div>
    <!--Modal and User-->
    <form action="/admin/save" method="post">
        <div class="modal fade" id="addModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel"
            aria-hidden="true">
            <div class="modal-dialog" role="document">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="exampleModalLabel">Add New User</h5>
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </div>
                    <div class="modal-body">
                        <div class="form-group">
                            <label>Name</label>
                            <input type="text" class="form-control" name="user_name" placeholder="User Name">
                        </div>
                        <div class="form-group">
                            <label>Email</label>
                            <input type="text" class="form-control" name="user_email" placeholder="Email">
                        </div>
                        <div class="form-group">
                            <label>Password</label>
                            <input type="text" class="form-control" name="user_password" placeholder="Password">
                        </div>
                        <div class="form-group">
                            <label>Contact</label>
                            <input type="text" class="form-control" name="user_contact" placeholder="Phone Number">
                        </div>
                        <div class="form-group">
                            <label>Address</label>
                            <input type="text" class="form-control" name="user_address" placeholder="Address">
                        </div>
                    </div>

                    <div class="modal-footer">
                        <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                        <button type="submit" class="btn btn-primary">Save</button>
                    </div>
                </div>
            </div>
        </div>
    </form>

    <!--Edit-->
    <form action="/admin/update" method="post">
        <div class="modal fade" id="editModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel"
            aria-hidden="true">
            <div class="modal-dialog" role="document">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="exampleModalLabel">Edit User</h5>
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </div>
                    <div class="modal-body">

                        <div class="form-group">
                            <label>Name</label>
                            <input type="text" class="form-control user_name" name="user_name" placeholder="User Name">
                        </div>

                        <div class="form-group">
                            <label>Email</label>
                            <input type="text" class="form-control user_email" name="user_email" placeholder="Email">
                        </div>

                        <div class="form-group">
                            <label>Password</label>
                            <input type="text" class="form-control user_password" name="user_password"
                                placeholder="Password">
                        </div>

                        <div class="form-group">
                            <label>Contact</label>
                            <input type="text" class="form-control user_contact" name="user_contact"
                                placeholder="Phone Number">
                        </div>

                        <div class="form-group">
                            <label>Address</label>
                            <input type="text" class="form-control user_address" name="user_address"
                                placeholder="Address">
                        </div>

                    </div>
                    <div class="modal-footer">
                        <input type="hidden" name="user_id" class="user_id">
                        <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                        <button type="submit" class="btn btn-primary">Update</button>
                    </div>
                </div>
            </div>
        </div>
    </form>

    <!--Delete-->
    <form action="/admin/delete" method="post">
        <div class="modal fade" id="deleteModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel"
            aria-hidden="true">
            <div class="modal-dialog" role="document">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="exampleModalLabel">Delete User</h5>
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </div>
                    <div class="modal-body">

                        <h4>Are you sure want to delete this user?</h4>

                    </div>
                    <div class="modal-footer">
                        <input type="hidden" name="user_id" class="userID">
                        <button type="button" class="btn btn-secondary" data-dismiss="modal">No</button>
                        <button type="submit" class="btn btn-primary">Yes</button>
                    </div>
                </div>
            </div>
        </div>
    </form>
    <script src="/js/jquery.min.js"></script>
    <script src="/js/bootstrap.bundle.min.js"></script>
    <script>
    $(document).ready(function(){
 
        // get Edit Product
        $('.btn-edit').on('click',function(){
            // get data from button edit
            const id = $(this).data('id');
            const name = $(this).data('name');
            const email = $(this).data('email');
            const password = $(this).data('password');
            const contact = $(this).data('contact');
            const address = $(this).data('address');
            // Set data to Form Edit
            $('.user_id').val(id);
            $('.user_name').val(name);
            $('.user_email').val(email);
            $('.user_password').val(password);
            $('.user_contact').val(contact);
            $('.user_address').val(address);
            // Call Modal Edit
            $('#editModal').modal('show');
        });
 
        // get Delete Product
        $('.btn-delete').on('click',function(){
            // get data from button edit
            const id = $(this).data('id');
            // Set data to Form Edit
            $('.userID').val(id);
            // Call Modal Edit
            $('#deleteModal').modal('show');
        });
         
    });
</script>
</body>